#!/bin/sh

#$1='-s'
#$2='SMART error (OfflineUncorrectableSector) detected on host: nsa210'
#$3='root'
#SMARTD_ADDRESS='root'
#SMARTD_DEVICE='/dev/sda'
#SMARTD_DEVICESTRING='/dev/sda'
#SMARTD_DEVICETYPE='ata'
#SMARTD_FAILTYPE='OfflineUncorrectableSector'
#SMARTD_FULLMESSAGE='This email was generated by the smartd daemon running on:
#
#   host name: nsa210
#  DNS domain: localdomain
#  NIS domain: localdomain
#
#The following warning/error was logged by the smartd daemon:
#
#Device: /dev/sda, 2 Offline uncorrectable sectors
#
#For details see host'"'"'s SYSLOG (default: /var/log/messages).
#
#You can also use the smartctl utility for further investigation.
#No additional email messages about this problem will be sent.
#'
#SMARTD_MESSAGE='Device: /dev/sda, 2 Offline uncorrectable sectors'
#SMARTD_SUBJECT='SMART error (OfflineUncorrectableSector) detected on host: nsa210'

apath=`echo $PATH|grep "zy-pkgs"`
if [ "${apath}" == "" ]; then
	. /etc/profile
fi

devdisk1=`sg_map -x -i|grep " 0 0 0 0"|awk '{print $7}'`
devdisk2=`sg_map -x -i|grep " 1 0 0 0"|awk '{print $7}'`
modelname=`cat /etc/modelname`

zysh_cli() {
	if [ "${devdisk1}" != "" ]; then
		zyshclient -p 150 -e "configure terminal smart showDiskPerformance ${devdisk1}"
		ret1=$?
	fi

	if [ "${devdisk2}" != "" ]; then
		zyshclient -p 150 -e "configure terminal smart showDiskPerformance ${devdisk2}"
		ret2=$?
	fi
}


# cli mode
if [ "${1}" == "cli" ]; then
	zysh_cli
	exit $((${ret1}|${ret2}))
fi

# startup mode: iSATA only
if [ "${1}" == "startup" ]; then
	#zysh_cli

	# add crontab
	addcron=`cat /var/spool/cron/crontabs/root|grep smart`
	if [ "${addcron}" == "" ]; then
		echo "25 */8 * * * smartd-runner.sh cli > /dev/null 2>&1" >> /var/spool/cron/crontabs/root
	fi

	# polling every 2 hours
	if [ -e /proc/scsi/mvSata/ ]; then
		if [ "${devdisk1}" != "" ]; then
			echo "${devdisk1} -d marvell -a -n standby -m root -M exec smartd-runner.sh" > /etc/smartd.conf
		fi
		if [ "${devdisk2}" != "" ]; then
			if [ "${modelname}" == "NSA221" ] || [ "${modelname}" == "NSA-220" ] || [ "${modelname}" == "NSA-220 PLUS" ] || [ "${modelname}" == "ServerBox" ]; then
				echo "${devdisk2} -d marvell -a -n standby -m root -M exec smartd-runner.sh" >> /etc/smartd.conf
			fi
		fi
	else
		if [ "${devdisk1}" != "" ]; then
			echo "${devdisk1} -d ata -a -n standby -m root -M exec smartd-runner.sh" > /etc/smartd.conf
		fi
		if [ "${devdisk2}" != "" ]; then
			if [ "${modelname}" == "NSA221" ] || [ "${modelname}" == "NSA-220" ] || [ "${modelname}" == "NSA-220 PLUS" ] || [ "${modelname}" == "ServerBox" ]; then
				echo "${devdisk2} -d ata -a -n standby -m root -M exec smartd-runner.sh" >> /etc/smartd.conf
			fi
		fi
	fi
	ran=`ps www|grep smartd|grep -v grep|grep -v ${0##/*/}`
	if [ "${ran}" == "" ]; then
		smartd -c /etc/smartd.conf -i 7200
		ret=$?
	else
		killall -HUP smartd
	fi
	exit $ret
fi

if [ "${SMARTD_DEVICE}" == "" ]; then
	echo "$0 cli|startup"
	exit 0
fi

# mail mode
#disk1 SMART error (OfflineUncorrectableSector) detected on host: nsa210, Device: /dev/sda, 2 Offline uncorrectable sectors
diskx=`grep ${SMARTD_DEVICE} /tmp/diskmap.map|awk '{print $1}'`
zylogger -s 28 -p 0 -f 28 "${diskx} ${SMARTD_SUBJECT}, ${SMARTD_MESSAGE}"

if [ "${modelname}" == "NSA310" ] && [ ! -e /tmp/smart_reported ]; then
	TMP_TOKEN_INFO=`/usr/bin/python /usr/local/apache/web_framework/bin/run_model register_main_model get_auth_info nasId nasCallingHomeDiskSiteAuthenticationToken 2>&1`
	nasId=`/bin/echo "${TMP_TOKEN_INFO}" | /bin/grep "nasId:" | /bin/awk -F':' '{print $2}'`
	nasCallingHomeDiskSiteAuthenticationToken=`/bin/echo "${TMP_TOKEN_INFO}" | /bin/grep "nasCallingHomeDiskSiteAuthenticationToken:" | /bin/awk -F':' '{print $2}'`

	if [ "${nasId}" != "" ] && [ "${nasCallingHomeDiskSiteAuthenticationToken}" != "" ]; then
		echo /usr/bin/curl --insecure -d "nasId=${nasId}" -d "nasCallingHomeDiskSiteAuthenticationToken=${nasCallingHomeDiskSiteAuthenticationToken}" -d "alertCode=6" -d "alertMessage=${SMARTD_MESSAGE}" `cat /etc/tdc_alert` >> /i-data/.zyxel/storage.txt
		/usr/bin/curl --insecure -d "nasId=${nasId}" -d "nasCallingHomeDiskSiteAuthenticationToken=${nasCallingHomeDiskSiteAuthenticationToken}" -d "alertCode=6" -d "alertMessage=${SMARTD_MESSAGE}" `cat /etc/tdc_alert` >> /i-data/.zyxel/storage.txt 2>&1
		touch /tmp/smart_reported
	fi
fi
